﻿Public Class ApplicationViewModel
    Inherits BaseViewModel

    Dim DataService As New NoticeDataService

    Public Sub New()
        NotesVM = New NotesViewModel(DataService)
        AddNoteVM = New AddNoteViewModel
        CurrentView = NotesVM
    End Sub


    Private _currentView As Object
    Public Property CurrentView() As Object
        Get
            Return _currentView
        End Get
        Set(ByVal value As Object)
            ChangePropIfDifferent(value, _currentView)
        End Set
    End Property


    Private _notesVM As NotesViewModel
    Public Property NotesVM() As NotesViewModel
        Get
            Return _notesVM
        End Get
        Set(ByVal value As NotesViewModel)
            ChangePropIfDifferent(value, _notesVM)
        End Set
    End Property

    Private _addNoteVM As AddNoteViewModel
    Public Property AddNoteVM() As AddNoteViewModel
        Get
            Return _addNoteVM
        End Get
        Set(ByVal value As AddNoteViewModel)
            ChangePropIfDifferent(value, _addNoteVM)
        End Set
    End Property

    Public ReadOnly Property ShowAddNoteCommand As New RelayCommand(AddressOf ShowAddNoteCommand_Execute, Function(o) CurrentView IsNot AddNoteVM)
    Private Sub ShowAddNoteCommand_Execute(obj As Object)
        CurrentView = AddNoteVM
    End Sub

    Public ReadOnly Property AddNoteCommand As New RelayCommand(AddressOf AddNoteCommand_Execute, Function(o) CurrentView Is AddNoteVM)
    Private Sub AddNoteCommand_Execute(obj As Object)
        NotesVM.Notes.Add(AddNoteVM.NewNote)
        NotesVM.SelectedNote = AddNoteVM.NewNote
        AddNoteVM.NewNote = New NoteViewModel
        CurrentView = NotesVM
    End Sub
End Class